﻿Public Class formSocketCliente

    Dim WithEvents socketCliente As New ClaseClienteSocket

    Private Sub btEnviar_Click(sender As System.Object,
             e As System.EventArgs) Handles btEnviar.Click
        Try
            'Enviar mensaje al servidor
            socketCliente.EnviarDatos(txtMensaje.Text)
        Catch err As Exception
            MsgBox("Error al enviar mensaje al servidor." &
                   vbCrLf & vbCrLf & err.Message)
        End Try
    End Sub

    'Evento que se ejecuta cuando se reciben datos
    Private Sub socketCliente_DatosRecibidos( _
            ByVal datos As String) Handles socketCliente.DatosRecibidos
        bePanel2.Text = "Recibidos datos del servidor"
        txtMensajeRecibido.Text = Now + " Servidor: " & datos
    End Sub

    Private Sub socketCliente_ConexionTerminada() Handles _
            socketCliente.ConexionTerminada
        bePanel2.Text = "Conexión finalizada"
        txtServidor.Enabled = True
        txtPuerto.Enabled = True
        btConectar.Enabled = True
        btDesconectar.Enabled = False
        btEnviar.Enabled = False
        txtListaMensajes.Enabled = False
        bePanel1.Text = "No conectado"
        txtServidor.Focus()
    End Sub

    Private Sub btConectar_Click(sender As System.Object,
            e As System.EventArgs) Handles btConectar.Click
        'Conexión del cliente con el servidor (IP ó hostname y puerto)
        If txtServidor.Text = "" Or txtPuerto.Text = "" Then
            MsgBox("Debe indicar el servidor (IP o hostname) y " _
                   & "el puerto al que realizar la conexión.",
                   MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
            txtServidor.Focus()
        Else
            Try
                socketCliente.IP = txtServidor.Text
                socketCliente.Puerto = CInt(txtPuerto.Text)

                socketCliente.Conectar()

                txtServidor.Enabled = False
                txtPuerto.Enabled = False
                btConectar.Enabled = False
                btEnviar.Enabled = True
                txtMensaje.Enabled = True
                btDesconectar.Enabled = True
                bePanel1.Text = "Conectado"
                bePanel1.Text = "Conexión establecida a " & txtServidor.Text & ":" & txtPuerto.Text
            Catch err As Exception
                bePanel1.Text = "No conectado"
                MsgBox("Error al conectar al servidor " & txtServidor.Text &
                       vbCrLf & vbCrLf & err.Message,
                       MsgBoxStyle.Critical + MsgBoxStyle.OkOnly)
            End Try
        End If
    End Sub

    Private Sub formSocketCliente_FormClosed(sender As System.Object,
             e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        End
    End Sub

    Private Sub btDesconectar_Click(sender As System.Object, e As System.EventArgs) Handles btDesconectar.Click
        txtServidor.Enabled = True
        txtPuerto.Enabled = True
        btConectar.Enabled = True
        btEnviar.Enabled = False
        txtMensaje.Enabled = False
        btDesconectar.Enabled = False
        Try
            socketCliente.Desconectar()
        Catch err As Exception
            MsgBox("Error al desconectar del servidor " & txtServidor.Text &
                 vbCrLf & vbCrLf & err.Message,
                 MsgBoxStyle.Critical + MsgBoxStyle.OkOnly)
        End Try
    End Sub
End Class